//Character-Encoding: UTF-8
// ---------------------------------------------------
//  nekoFlash.swf のソースファイル
//  by てなさく <tenasaku@tenasaku.com>
// ---------------------------------------------------
//   Kenji Gotoh さんの 名高いフリーウェア 
//   "neko DA" へのトリビュートです
//   画像データは Kouji Ishida さんの nekoJava アプレット
//   のソースから コピーさせてもらいました
//   お二人に感謝いたします
// ---------------------------------------------------
// 2010年3月11日木曜日: ベータ公開
// ---------------------------------------------------
package {

	import flash.display.*;
	import flash.net.*;
	import flash.text.*;
	import flash.events.*;

	public class Main extends Sprite {


		// neko の動作(関数)の配列
		private const nekoBehavior:Array = [
			tomariNeko,
			nakiNeko,
			mimiNeko,
			hatenaNeko,
			hiramekiNeko,
			nemuNeko,
			hasiriNekoN,
			hasiriNekoNE,
			hasiriNekoE,
			hasiriNekoSE,
			hasiriNekoS,
			hasiriNekoSW,
			hasiriNekoW,
			hasiriNekoNW,
			kabeNekoN,
			kabeNekoE,
			kabeNekoS,
			kabeNekoW
		];

		// neko の動作の規定の持続時間
		// ゼロは持続時間無制限を意味する
		private const nekoTimer:Array = [
			30, // 停止
			30, // 鳴く
			20, // 耳を掻く
			30, // 首をかしげる
			20, // 何かひらめく
			0, // 寝る
			0, // 走る(北)
			0, // 走る(北東)
			0, // 走る(東)
			0, // 走る(南東)
			0, // 走る(南)
			0, // 走る(南西)
			0, // 走る(西)
			0, // 走る(北西
			60, // 壁を引っ掻く(北)
			60, // 壁を引っ掻く(東)
			60, // 壁を引っ掻く(南)
			60 // 壁を引っ掻く(西)
		];


		// 上記ふたつの配列の添字にわかりやすい名前をつける
		private const TOMARU:int = 0;
		private const NAKU:int = 1;
		private const MIMI:int = 2;
		private const HATENA:int = 3;
		private const HIRAMEKU:int = 4;
		private const NEMURU:int = 5;
		private const HASIRU_N:int = 6;
		private const HASIRU_NE:int = 7;
		private const HASIRU_E:int = 8;
		private const HASIRU_SE:int = 9;
		private const HASIRU_S:int = 10;
		private const HASIRU_SW:int = 11;
		private const HASIRU_W:int = 12;
		private const HASIRU_NW:int = 13;
		private const KABE_N:int = 14;
		private const KABE_E:int = 15;
		private const KABE_S:int = 16;
		private const KABE_W:int = 17;

		private const _TOOLONG:int = 900; // これ以上長く放っとくと寝る

		private var nekoImg:Array; // 画像データを保持する配列

		private var nekoX:Number; // neko の現在位置横座標
		private var nekoY:Number; // neko の現在位置縦座標

		private var _time:int; // 動作制御用の時間変数
		private var _timeToDo:int; // 現在の動作の残り時間
		private var _stay:int; // マウスに追いついた状態がどれだけ続いたか
		private var _whatToDo:int; // neko 動作の種別

		private var _monitor:TextField; // 状態表示用フィールド
		private var _monitorFmt:TextFormat;
		private var _about:TextField; // アバウト画面
		private var _aboutFmt:TextFormat;

		// 名前こそ Main だけど 実際には エントリーポイント
		public function Main ():void {
			// ステージを固定
			stage.align = StageAlign.TOP_LEFT;
			stage.scaleMode = StageScaleMode.NO_SCALE;
			// 背景色を変える
			this.graphics.beginFill(0xffcc99);
			this.graphics.drawRect(0,0,stage.stageWidth,stage.stageHeight);
			this.graphics.endFill();
			// ネコの画像セットを配列に読み込み表示リストに載せる
			nekoImg = new Array();
			nekoImg = [];
			loadImages();
			// 状態表示フィールドを初期化
			_monitor = new TextField();
			_monitor.width = stage.stageWidth*0.4;
			_monitor.height = stage.stageHeight*0.4;
			if (_monitor.height < 200) { _monitor.height = 200; }
			_monitor.x = 0;
			_monitor.y = 0;
			_monitor.selectable = false;
			_monitor.background = true;
			_monitor.backgroundColor = 0x000000;
			_monitor.alpha = 0.6;
			_monitor.visible = false;
			_monitor.textColor = 0xffff00;
			_monitor.text = "";
			_monitorFmt = new TextFormat();
			_monitorFmt.size = 12;
			_monitorFmt.leftMargin = 2;
			_monitorFmt.leading = 2;
			_monitor.setTextFormat(_monitorFmt);
			this.addChild(_monitor);
			// アバウト画面を初期化
			_about = new TextField();
			_about.width = 240;
			_about.height =120;
			_about.x = (stage.stageWidth-_about.width)/2;
			_about.y = (stage.stageHeight-_about.height)/2;
			_about.selectable = false;
			_about.background = true;
			_about.backgroundColor = 0xffffff;
			_about.alpha = 1.0;
			_about.visible = false;
			_about.textColor = 0x000080;
			_about.text = "neko Flash\n(a tribute to neko DA)\n\n[beta version: March 11 2010]\nby Tenasaku <tenasaku@tenasaku.com>";
			_aboutFmt = new TextFormat();
			_aboutFmt.align = TextFormatAlign.CENTER;
			_aboutFmt.size = 12;
			_aboutFmt.leading = 3;
			_about.setTextFormat(_aboutFmt);
			this.addChild(_about);
			// 各パラメータを初期化
			nekoX = Math.floor(stage.stageWidth/2);
			nekoY = Math.floor(stage.stageHeight/2);
			_time = 0;
			_timeToDo = 0;
			_whatToDo = 0;
			_stay = 0;
			// イベントリスナーを登録
			stage.addEventListener(Event.ENTER_FRAME, atEveryFrame);
			stage.addEventListener(MouseEvent.CLICK, whenYouClick);
		}

		// ENTER FRAME イベントの処理 (メインループの処理)
		private function atEveryFrame(e:Event):void {
			nekoLife(); // neko の行動を制御 (なに. ネコの制御なんて, できるもんかね!!)
			_time = (++_time)%36000; // 行動制御用の時間変数
			// 情報フィールドの更新
			_monitor.text = "Time:\t " + String(_time);
			_monitor.appendText("\n\nnekoX:\t "+String(nekoX));
			_monitor.appendText("\nnekoY:\t "+String(nekoY));
			_monitor.appendText("\nmouseX:\t "+String(mouseX));
			_monitor.appendText("\nmouseY:\t "+String(mouseY));
			_monitor.appendText("\nwhat:\t "+nekoIs());
			_monitor.appendText("\nremain:\t "+String(_timeToDo));
			_monitor.appendText("\nstayed:\t "+String(_stay));
			_monitor.appendText("\n\nwidth:\t "+String(stage.stageWidth));
			_monitor.appendText("\nheight:\t "+String(stage.stageHeight));
		}

		// CLICK イベントの処理
		// TODO: neko がクリックされたかどうか判定して, 反応を変える
		private function whenYouClick(e:MouseEvent):void {
			if ( _about.visible ) {
				_about.visible = false;
			} else {
				if (e.shiftKey) {
					_monitor.visible = ! _monitor.visible;
				} else {
					if (e.altKey) {
					_about.visible = true;
					} else {
						if ( _stay > 0 ) { // それなりに反応する
							_timeToDo = nekoTimer[(_whatToDo = NAKU)];
							_time = 0;
						}
					}
				}
			}
		}

		// nekoImg 配列に画像をロードする
		// TODO: ロードに失敗したときの判断とエラー処理が必要では？
		private function loadImages():void {
			const cutAfter:int = this.loaderInfo.url.lastIndexOf("/");
			const imageBase:String = this.loaderInfo.url.substr(0,cutAfter+1);
			var tx:TextField = new TextField;
			tx.width = stage.stageWidth-10;
			tx.height = 120;
			tx.textColor = 0;
			tx.x = 10;
			tx.y = 10;
			this.addChild(tx);
			var i:int = 1;
			while ( i <= 32 ) {
				tx.text = "loading image no."+String(i)+" of 32...";
				nekoImg[i] = new Loader();
				nekoImg[i].load(new URLRequest(imageBase+"nekoGIF/"+String(i)+".gif"));
				nekoImg[i].x = 100;
				nekoImg[i].y = 100;
				nekoImg[i].visible = false;
				this.addChild(nekoImg[i]);
				++i;
			}
			this.removeChild(tx);
		}

		// 何をしているか文字列で返す
		private function nekoIs():String {
			const strArray:Array = [
				"pausing",
				"mewing",
				"grooming",
				"thinking",
				"got an idea",
				"sleeping",
				"running (N)",
				"running (NE)",
				"running (E)",
				"running (SE)",
				"running (S)",
				"running (SW)",
				"running (W)",
				"running (NW)",
				"scratching (N)",
				"scratching (E)",
				"scratching (S)",
				"scratching (W)"
			];
			if ((_whatToDo >= 0)&&(_whatToDo< nekoBehavior.length)) {
				return strArray[_whatToDo];
			} else {
				return "unknown";
			}
		}

		/* ----------------------------------------
		 * neko をコントロールする主要部分
		 * ----------------------------------------
		 */
		private function nekoLife():void {
			var dx:Number = mouseX - nekoX;
			var dy:Number = mouseY - nekoY;
			var distance:Number = Math.max(Math.abs(dx),Math.abs(dy));
			if ( distance >= 16 ) { // マウスが離れた
				// 停留時間, 継続時間をゼロにする
				_stay = 0;
				_timeToDo = 0;
				_whatToDo = 0;
				nekoRuns(dx,dy); // マウスを追いかける
			} else {
				++ _stay;
				if ( _timeToDo > 0 ) {
					-- _timeToDo; // 継続時間を1コマ消費して
					// 現在の動作を継続
					if ( ( _whatToDo >= 0 ) && ( _whatToDo < nekoBehavior.length ) ) {
						nekoBehavior[_whatToDo](); 
					} else { // 未定義の動作番号なら
						nekoBehavior[ (_whatToDo = TOMARU) ](); // しかたがないので止まる
					}
				} else { // 次の行動に移るか、なにもせず寝る
					if ( _stay >= _TOOLONG ) { // マウスが長時間動かないとき
						_stay = _TOOLONG; // これ以上停留時間をカウントしない
						nekoBehavior[ (_whatToDo = NEMURU) ](); // 眠る
					} else { // 追いついてまだ時間が浅いとき
						if ( _stay < 10 ) { // 追いついたら一旦おちつく
							_timeToDo = nekoTimer[(_whatToDo = TOMARU)] - _stay;
						} else { // 次の動作を選び、その継続時間を設定する
							_whatToDo = _whatToDo = Math.floor(Math.random()*4.999);
							_timeToDo = nekoTimer[_whatToDo];
							_time = 0; 	// 制御時間をリセットする
						}
					}
				}
			}
		}

		/* ----------------------------------------
			最も基本的な neko 表示手続き
			与えられた番号 imgNo に対応する画像を
			現在の neko 座標 (nekoX, nekoY) に表示する
			neko 座標の基準点は画像の中央に置く
			範囲外の imgNo を指定すると neko が消えちまうぞ
			----------------------------------------
		 */
		private function _putNeko(imgNo:int):void {
			var i:int;
			for ( i = 1 ; i <= 32 ; ++i ) {
				nekoImg[i].visible = ( i == imgNo );
				nekoImg[i].x = nekoX-16; // ここの 16 は 画像サイズの半分
				nekoImg[i].y = nekoY-16; // 決め打ちにせず計算すべきかな...
			}
		}

		// マウスを追う動作をさせる
		/* FIXME: -----------------------------------------------
			マウスがステージ外にある場合, なんらかのタイミングで
			きちんと定義された「マウスがいないときの動作」に移るべきだ
			現在の処理はけっこうズサン... (2010年3月10日水曜日 11:59:58)
			------------------------------------------------------
		 */
		private function nekoRuns(dx:Number,dy:Number):void {
			// ステージの外にはみ出さないように動きを制限する
			if ( ( dx < 0 ) && ( nekoX <= 16 ) ) { dx = 0; }
			if ( ( dx > 0 ) && ( nekoX >= stage.stageWidth-17 ) ) { dx = 0; }
			if ( ( dy < 0 ) && ( nekoY <= 16 ) ) { dy = 0; }
			if ( ( dy > 0 ) && ( nekoY >= stage.stageHeight-17 ) ) { dy = 0; }
			// 動く向きを判定する
			var m:int = 4;
			if ( dx <= -16 ) { m -= 1; }
			if ( dx >= +16 ) { m += 1; }
			if ( dy <= -16 ) { m -= 3; }
			if ( dy >= +16 ) { m += 3; }
			switch ( m ) {
				case 0: // 北西
					_whatToDo = HASIRU_NW;
					break;
				case 1: // 北
					_whatToDo = HASIRU_N;
					break;
				case 2: // 北東
					_whatToDo = HASIRU_NE
					break;
				case 3: // 西
					_whatToDo = HASIRU_W
					break;
				case 4: // 八方向のどれでもない... 壁際では?
					_whatToDo = TOMARU; // デフォルト(停止)
					if ( nekoX <= 16 ) { // 西の壁をこする
						_whatToDo = KABE_W;
					} else {
						if ( nekoX >= stage.stageWidth-17 ) { // 東の壁をこする
							_whatToDo = KABE_E;
						} else {
							if ( nekoY <= 16 ) { // 北の壁をこする
								_whatToDo = KABE_N;
							} else {
								if ( nekoY >= stage.stageHeight-17 ) { // 南の壁をこする
									_whatToDo = KABE_S;
								}
							}
						}
					}
					// 長く続ければ飽きて停止
					if ( _time >= _TOOLONG ) { _whatToDo = TOMARU; }
					break;
				case 5: // 東
					_whatToDo = HASIRU_E
					break;
				case 6: // 南西
					_whatToDo = HASIRU_SW
					break;
				case 7: // 南
					_whatToDo = HASIRU_S
					break;
				case 8: // 南東
					_whatToDo = HASIRU_SE
			}
			nekoBehavior[_whatToDo]();
		}

		/* ---------------------------------------
			以下は nekoBehavior 配列の要素となっている
			関数の実装...
			---------------------------------------
		 */

		// Neko の各種動作 (瞬間ごとの挙動)
		// 正面を向いて停止
		private function tomariNeko():void {
			_putNeko( 25 );
		}
		// 眠る動作
		private function nemuNeko():void { 
			_putNeko( (_time%30<15)?29:30 );
		}
		// 口をあける(鳴く? あくび?)動作
		private function nakiNeko():void { 
			_putNeko( ((_time+4)%30<8)?25:26 )
		}
		// 耳を掻く動作
		private function mimiNeko():void { 
			_putNeko( (_time%4<2)?27:28 );
		}
		// 首をかしげる(顔洗い?)動作
		private function hatenaNeko():void { 
			_putNeko( ((_time+5)%30<10)?25:31 );
		}
		// 何か閃く
		private function hiramekiNeko():void { 
			_putNeko( (_time%10)<8?32:25 );
		}
		// 八方向のそれぞれに走る動作
		private function hasiriNekoN():void { // 北向き
			var imgNo:int = (_time%10<5)?1:2;
			if ( imgNo%2 == 0 ) {
				nekoY -= 1;
			} else {
				nekoY -= 4;
			}
			if ( nekoY < 16 ) { nekoY = 16; }
			_putNeko( imgNo );
		}
		private function hasiriNekoNE():void { // 北東向き
			var imgNo:int = (_time%10<5)?3:4;
			if ( imgNo%2 == 0 ) {
				nekoX += 1;
				nekoY -= 1;
			} else {
				nekoX += 3;
				nekoY -= 3;
			}
			if (nekoX > stage.stageWidth - 16) { nekoX = stage.stageWidth - 16; }
			if (nekoY < 16) { nekoY = 16; }
			_putNeko( imgNo );
		}
		private function hasiriNekoE():void { // 東向き
			var imgNo:int = (_time%10<5)?5:6;
			if ( imgNo%2 == 0 ) {
				nekoX += 1;
			} else {
				nekoX += 4;
			}
			if ( nekoX > stage.stageWidth - 16 ) { nekoX = stage.stageWidth - 16; }
			_putNeko( imgNo );
		}
		private function hasiriNekoSE():void { // 南東向き
			var imgNo:int = (_time%10<5)?7:8;
			if ( imgNo%2 == 0 ) {
				nekoX += 1;
				nekoY += 1;
			} else {
				nekoX += 3;
				nekoY += 3;
			}
			if ( nekoX > stage.stageWidth - 16 ) { nekoX = stage.stageWidth - 16; }
			if ( nekoY > stage.stageHeight - 16 ) { nekoY = stage.stageHeight - 16; }
			_putNeko( imgNo );
		}
		private function hasiriNekoS():void { // 南向き
			var imgNo:int = (_time%10<5)?9:10;
			if ( imgNo%2 == 0 ) {
				nekoY += 1;
			} else {
				nekoY += 4;
			}
			if ( nekoY > stage.stageHeight - 16 ) { nekoY = stage.stageHeight - 16; }
			_putNeko( imgNo );
		}
		private function hasiriNekoSW():void { // 南西向き
			var imgNo:int = (_time%10<5)?11:12;
			if ( imgNo%2 == 0 ) {
				nekoX -= 1;
				nekoY += 1;
			} else {
				nekoX -= 3;
				nekoY += 3;
			}
			if ( nekoX < 16 ) { nekoX = 16; }
			if ( nekoY > stage.stageHeight - 16 ) { nekoY = stage.stageHeight - 16; }
			_putNeko( imgNo );
		}
		private function hasiriNekoW():void { // 西向き
			var imgNo:int = (_time%10<5)?13:14;
			if ( imgNo%2 == 0 ) {
				nekoX -= 1;
			} else {
				nekoX -= 4;
			}
			if ( nekoX < 16 ) { nekoX = 16; }
			_putNeko( imgNo );
		}
		private function hasiriNekoNW():void { // 北西向き
			var imgNo:int = (_time%10<5)?15:16;
			if ( imgNo%2 == 0 ) {
				nekoX -= 1;
				nekoY -= 1;
			} else {
				nekoX -= 3;
				nekoY -= 3;
			}
			if ( nekoX < 16 ) { nekoX = 16; }
			if ( nekoY < 16 ) { nekoY = 16; }
			_putNeko( imgNo );
		}
		// 四方の壁を引っ掻く動作
		// _timeToDo = 60 くらいがよさそう
		private function kabeNekoN():void { // 北の壁
			_putNeko( (_time%15<7)?17:18 );
		}
		private function kabeNekoE():void { // 東の壁
			_putNeko( (_time%15<7)?19:20 );
		}
		private function kabeNekoS():void { // 南の壁
			_putNeko( (_time%15<7)?21:22 );
		}
		private function kabeNekoW():void { // 西の壁
			_putNeko( (_time%15<7)?23:24 );
		}

	}

}
